// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from dataspeed_dbw_msgs:msg/SteeringReport.idl
// generated code does not contain a copyright notice
#include "dataspeed_dbw_msgs/msg/detail/steering_report__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
dataspeed_dbw_msgs__msg__SteeringReport__init(dataspeed_dbw_msgs__msg__SteeringReport * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    dataspeed_dbw_msgs__msg__SteeringReport__fini(msg);
    return false;
  }
  // steering_wheel_angle
  // steering_wheel_cmd
  // steering_wheel_torque
  // steering_wheel_cmd_type
  // speed
  // enabled
  // override
  // timeout
  // fault_wdc
  // fault_bus1
  // fault_bus2
  // fault_calibration
  // fault_power
  return true;
}

void
dataspeed_dbw_msgs__msg__SteeringReport__fini(dataspeed_dbw_msgs__msg__SteeringReport * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // steering_wheel_angle
  // steering_wheel_cmd
  // steering_wheel_torque
  // steering_wheel_cmd_type
  // speed
  // enabled
  // override
  // timeout
  // fault_wdc
  // fault_bus1
  // fault_bus2
  // fault_calibration
  // fault_power
}

dataspeed_dbw_msgs__msg__SteeringReport *
dataspeed_dbw_msgs__msg__SteeringReport__create()
{
  dataspeed_dbw_msgs__msg__SteeringReport * msg = (dataspeed_dbw_msgs__msg__SteeringReport *)malloc(sizeof(dataspeed_dbw_msgs__msg__SteeringReport));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(dataspeed_dbw_msgs__msg__SteeringReport));
  bool success = dataspeed_dbw_msgs__msg__SteeringReport__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
dataspeed_dbw_msgs__msg__SteeringReport__destroy(dataspeed_dbw_msgs__msg__SteeringReport * msg)
{
  if (msg) {
    dataspeed_dbw_msgs__msg__SteeringReport__fini(msg);
  }
  free(msg);
}


bool
dataspeed_dbw_msgs__msg__SteeringReport__Sequence__init(dataspeed_dbw_msgs__msg__SteeringReport__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  dataspeed_dbw_msgs__msg__SteeringReport * data = NULL;
  if (size) {
    data = (dataspeed_dbw_msgs__msg__SteeringReport *)calloc(size, sizeof(dataspeed_dbw_msgs__msg__SteeringReport));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = dataspeed_dbw_msgs__msg__SteeringReport__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        dataspeed_dbw_msgs__msg__SteeringReport__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
dataspeed_dbw_msgs__msg__SteeringReport__Sequence__fini(dataspeed_dbw_msgs__msg__SteeringReport__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      dataspeed_dbw_msgs__msg__SteeringReport__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

dataspeed_dbw_msgs__msg__SteeringReport__Sequence *
dataspeed_dbw_msgs__msg__SteeringReport__Sequence__create(size_t size)
{
  dataspeed_dbw_msgs__msg__SteeringReport__Sequence * array = (dataspeed_dbw_msgs__msg__SteeringReport__Sequence *)malloc(sizeof(dataspeed_dbw_msgs__msg__SteeringReport__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = dataspeed_dbw_msgs__msg__SteeringReport__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
dataspeed_dbw_msgs__msg__SteeringReport__Sequence__destroy(dataspeed_dbw_msgs__msg__SteeringReport__Sequence * array)
{
  if (array) {
    dataspeed_dbw_msgs__msg__SteeringReport__Sequence__fini(array);
  }
  free(array);
}
